/*******************************************************************************
 * LinkedList
 *
 * A simple doubly linked list class in C.
 *
 *
 * Test driver for LinkedList
 *
 ******************************************************************************/

#include "LinkedList.h"

#include <stdio.h>
#include <stdlib.h>


typedef struct mode_info mode_info;
struct mode_info
   {
   int          sizeid;
   int          w;
   int          h;
   int          r;
   };

int main (int argc, char ** argv)
   {
   LinkedList list1;
   LinkedList list2;
   LinkedList * list3;

   int * p_int;
   mode_info * p_mode;

   int i;
   int size;


   ll_init(&list1);
   ll_init(&list2);

   for (i=0; i<10; ++i)
      {
      p_int = malloc(sizeof(int));
      *p_int = i;
      list1.push(&list1, p_int);
      }
   p_int = malloc(sizeof(int));
   *p_int = 17;
   list1.push(&list1, p_int);

   list1.head(&list1);
   list1.next(&list1);
   p_int = malloc(sizeof(int));
   *p_int = 23;
   list1.insert(&list1, p_int);

   list1.tail(&list1);
   p_int = malloc(sizeof(int));
   *p_int = 109;
   list1.insert(&list1, p_int);

   list1.head(&list1);
   list1.next(&list1);
   list1.next(&list1);
   list1.next(&list1);
   list1.next(&list1);
   list1.next(&list1);
   free(list1.remove(&list1));

   list1.head(&list1);
   free(list1.remove(&list1));

   list1.tail(&list1);
   free(list1.remove(&list1));

   list1.prev(&list1);
   list1.prev(&list1);
   free(list1.remove(&list1));

   p_int = malloc(sizeof(int));
   *p_int = 77;
   list1.insert_at_head(&list1, p_int);



   p_mode = calloc(1, sizeof(mode_info));
   p_mode->sizeid = 1;
   p_mode->w = 640;
   p_mode->h = 480;
   p_mode->r = 60;
   list2.push(&list2, p_mode);

   p_mode = calloc(1, sizeof(mode_info));
   p_mode->sizeid = 2;
   p_mode->w = 800;
   p_mode->h = 600;
   p_mode->r = 85;
   list2.push(&list2, p_mode);

   p_mode = calloc(1, sizeof(mode_info));
   p_mode->sizeid = 3;
   p_mode->w = 1024;
   p_mode->h = 768;
   p_mode->r = 72; 
   list2.push(&list2, p_mode);

   p_mode = calloc(1, sizeof(mode_info));
   p_mode->sizeid = 4;
   p_mode->w = 1280;
   p_mode->h = 1024;
   p_mode->r = 60;
   list2.push(&list2, p_mode);


   printf("list2:\n");

   list2.head(&list2);
   size = list2.size(&list2);
   for (i=0; i<size; ++i)
      {
      p_mode = list2.data(&list2);
      printf("mode %d: %dx%d @ %d MHz\n", 
	     p_mode->sizeid, p_mode->w, p_mode->h, p_mode->r);
      list2.next(&list2);
      }
   printf("\n\n");

   size = list1.size(&list1);
   printf("List1 has %d elements\n", size);
   list1.head(&list1);
   for (i=0; i<size; ++i)
      {
      printf("%d ", *((int *) list1.data(&list1)) );
      fflush(stdout);
      list1.next(&list1);
      }
   printf("\n");

   for (i=0; i<size; ++i)
      {
      p_int = list1.pop(&list1);
      printf("%d\n", *p_int);
      free(p_int);
      }


   list3 = malloc(sizeof(LinkedList));
   if (!list3) 
      {
      printf("malloc failed!\n");
      exit(1);
      }

   p_int = malloc(sizeof(int));
   *p_int = 21;
   ll_push(list3, p_int);
   p_int = malloc(sizeof(int));
   *p_int = 22;
   ll_push(list3, p_int);
   p_int = malloc(sizeof(int));
   *p_int = 23;
   ll_push(list3, p_int);


   ll_head(list3);
   p_int = (int *) ll_data(list3);
   printf("list3: ");
   while(p_int)
      {
      printf("%d ", *p_int);
      p_int = ll_next(list3);
      }
   printf("\n");
   
   ll_tail(list3);
   p_int = (int *) ll_data(list3);
   printf("list3 reversed: ");
   while(p_int)
      {
      printf("%d ", *p_int);
      p_int = ll_prev(list3);
      }
   printf("\n");
   
   printf("Clearing list3: ");
   while (p_int = (int *) ll_pop(list3))
      {
      printf("%d ", *p_int);
      }
   printf("\n");

   return 0;
   }
